diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/examples/vanet-routing-compare.cc ns-3.34/src/wave/examples/vanet-routing-compare.cc
--- ns-3.33/src/wave/examples/vanet-routing-compare.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/examples/vanet-routing-compare.cc	2021-07-14 10:31:07.000000000 -0700
@@ -137,7 +137,6 @@
 public:
   /**
    * \brief Constructor
-   * \return none
    */
   RoutingStats ();
 
@@ -169,27 +168,23 @@
    * \brief Increments the number of (application-data)
    * bytes received, not including MAC/PHY overhead
    * \param rxBytes the number of bytes received
-   * \return none
    */
   void IncRxBytes (uint32_t rxBytes);
 
   /**
    * \brief Increments the count of packets received
-   * \return none
    */
   void IncRxPkts ();
 
   /**
    * \brief Sets the number of bytes received.
    * \param rxBytes the number of bytes received
-   * \return none
    */
   void SetRxBytes (uint32_t rxBytes);
 
   /**
    * \brief Sets the number of packets received
    * \param rxPkts the number of packets received
-   * \return none
    */
   void SetRxPkts (uint32_t rxPkts);
 
@@ -201,7 +196,7 @@
 
   /**
    * \brief Returns the cumulative number of bytes transmitted
-   * \return none
+   * \return the cumulative number of bytes transmitted
    */
   uint32_t GetCumulativeTxBytes ();
 
@@ -220,27 +215,23 @@
   /**
    * \brief Increment the number of bytes transmitted
    * \param txBytes the number of additional bytes transmitted
-   * \return none
    */
   void IncTxBytes (uint32_t txBytes);
 
   /**
    * \brief Increment the count of packets transmitted
-   * \return none
    */
   void IncTxPkts ();
 
   /**
    * \brief Sets the number of bytes transmitted
    * \param txBytes the number of bytes transmitted
-   * \return none
    */
   void SetTxBytes (uint32_t txBytes);
 
   /**
    * \brief Sets the number of packets transmitted
    * \param txPkts the number of packets transmitted
-   * \return none
    */
   void SetTxPkts (uint32_t txPkts);
 
@@ -388,13 +379,11 @@
 
   /**
    * \brief Constructor
-   * \return none
    */
   RoutingHelper ();
 
   /**
    * \brief Destructor
-   * \return none
    */
   virtual ~RoutingHelper ();
 
@@ -409,7 +398,6 @@
    * \param protocol the routing protocol (1=OLSR;2=AODV;3=DSDV;4=DSR)
    * \param nSinks the number of nodes which will act as data sinks
    * \param routingTables dump routing tables at t=5 seconds (0=no;1=yes)
-   * \return none
    */
   void Install (NodeContainer & c,
                 NetDeviceContainer & d,
@@ -423,7 +411,6 @@
    * \brief Trace the receipt of an on-off-application generated packet
    * \param context this object
    * \param packet a received packet
-   * \return none
    */
   void OnOffTrace (std::string context, Ptr<const Packet> packet);
 
@@ -436,7 +423,6 @@
   /**
    * \brief Enable/disable logging
    * \param log non-zero to enable logging
-   * \return none
    */
   void SetLogging (int log);
 
@@ -444,7 +430,6 @@
   /**
    * \brief Sets up the protocol protocol on the nodes
    * \param c node container
-   * \return none
    */
   void SetupRoutingProtocol (NodeContainer & c);
 
@@ -452,7 +437,6 @@
    * \brief Assigns IPv4 addresses to net devices and their interfaces
    * \param d net device container
    * \param adhocTxInterfaces IPv4 interface container
-   * \return none
    */
   void AssignIpAddresses (NetDeviceContainer & d,
                           Ipv4InterfaceContainer & adhocTxInterfaces);
@@ -461,7 +445,6 @@
    * \brief Sets up routing messages on the nodes and their interfaces
    * \param c node container
    * \param adhocTxInterfaces IPv4 interface container
-   * \return none
    */
   void SetupRoutingMessages (NodeContainer & c,
                              Ipv4InterfaceContainer & adhocTxInterfaces);
@@ -477,7 +460,6 @@
   /**
    * \brief Process a received routing packet
    * \param socket the receiving socket
-   * \return none
    */
   void ReceiveRoutingPacket (Ptr<Socket> socket);
 
@@ -659,6 +641,13 @@
     }
 }
 
+/**
+ * Print a received routing packet on a string
+ * \param socket Rx socket
+ * \param packet Rx packet
+ * \param srcAddress source address
+ * \return the built string
+ */
 static inline std::string
 PrintReceivedRoutingPacket (Ptr<Socket> socket, Ptr<Packet> packet, Address srcAddress)
 {
@@ -730,13 +719,11 @@
 
   /**
    * \brief Constructor
-   * \return none
    */
   WifiPhyStats ();
 
   /**
    * \brief Destructor
-   * \return none
    */
   virtual ~WifiPhyStats ();
 
@@ -754,7 +741,6 @@
    * \param mode wifi mode
    * \param preamble wifi preamble
    * \param txPower transmission power
-   * \return none
    */
   void PhyTxTrace (std::string context, Ptr<const Packet> packet, WifiMode mode, WifiPreamble preamble, uint8_t txPower);
 
@@ -762,7 +748,6 @@
    * \brief Callback signiture for Phy/TxDrop
    * \param context this object
    * \param packet the tx packet being dropped
-   * \return none
    */
   void PhyTxDrop (std::string context, Ptr<const Packet> packet);
 
@@ -770,9 +755,9 @@
    * \brief Callback signiture for Phy/RxDrop
    * \param context this object
    * \param packet the rx packet being dropped
-   * \return none
+   * \param reason the reason for the drop
    */
-  void PhyRxDrop (std::string context, Ptr<const Packet> packet);
+  void PhyRxDrop (std::string context, Ptr<const Packet> packet, WifiPhyRxfailureReason reason);
 
 private:
   uint32_t m_phyTxPkts; ///< phy transmit packets
@@ -818,7 +803,7 @@
 }
 
 void
-WifiPhyStats::PhyRxDrop (std::string context, Ptr<const Packet> packet)
+WifiPhyStats::PhyRxDrop (std::string context, Ptr<const Packet> packet, WifiPhyRxfailureReason reason)
 {
   NS_LOG_UNCOND ("PHY Rx Drop");
 }
@@ -838,13 +823,11 @@
 public:
   /**
    * \brief Constructor
-   * \return none
    */
   WifiApp ();
 
   /**
    * \brief Destructor
-   * \return none
    */
   virtual ~WifiApp ();
 
@@ -852,14 +835,12 @@
    * \brief Enacts simulation of an ns-3 wifi application
    * \param argc program arguments count
    * \param argv program arguments
-   * \return none
    */
   void Simulate (int argc, char **argv);
 
 protected:
   /**
    * \brief Sets default attribute values
-   * \return none
    */
   virtual void SetDefaultAttributeValues ();
 
@@ -867,55 +848,46 @@
    * \brief Process command line arguments
    * \param argc program arguments count
    * \param argv program arguments
-   * \return none
    */
   virtual void ParseCommandLineArguments (int argc, char **argv);
 
   /**
    * \brief Configure nodes
-   * \return none
    */
   virtual void ConfigureNodes ();
 
   /**
    * \brief Configure channels
-   * \return none
    */
   virtual void ConfigureChannels ();
 
   /**
    * \brief Configure devices
-   * \return none
    */
   virtual void ConfigureDevices ();
 
   /**
    * \brief Configure mobility
-   * \return none
    */
   virtual void ConfigureMobility ();
 
   /**
    * \brief Configure applications
-   * \return none
    */
   virtual void ConfigureApplications ();
 
   /**
    * \brief Configure tracing
-   * \return none
    */
   virtual void ConfigureTracing ();
 
   /**
    * \brief Run the simulation
-   * \return none
    */
   virtual void RunSimulation ();
 
   /**
    * \brief Process outputs
-   * \return none
    */
   virtual void ProcessOutputs ();
 };
@@ -1020,21 +992,18 @@
 public:
   /**
    * \brief Constructor
-   * \return none
    */
   ConfigStoreHelper ();
 
   /**
    * \brief Loads a saved config-store raw text configuration from a given named file
    * \param configFilename the name of the config-store raw text file
-   * \return none
    */
   void LoadConfig (std::string configFilename);
 
   /**
    * \brief Saves a configuration to a given named config-store raw text configuration file
    * \param configFilename the name of the config-store raw text file
-   * \return none
    */
   void SaveConfig (std::string configFilename);
 };
@@ -1081,14 +1050,12 @@
 public:
   /**
    * \brief Constructor
-   * \return none
    */
   VanetRoutingExperiment ();
 
 protected:
   /**
    * \brief Sets default attribute values
-   * \return none
    */
   virtual void SetDefaultAttributeValues ();
 
@@ -1096,62 +1063,52 @@
    * \brief Process command line arguments
    * \param argc program arguments count
    * \param argv program arguments
-   * \return none
    */
   virtual void ParseCommandLineArguments (int argc, char **argv);
 
   /**
    * \brief Configure nodes
-   * \return none
    */
   virtual void ConfigureNodes ();
 
   /**
    * \brief Configure channels
-   * \return none
    */
   virtual void ConfigureChannels ();
 
   /**
    * \brief Configure devices
-   * \return none
    */
   virtual void ConfigureDevices ();
 
   /**
    * \brief Configure mobility
-   * \return none
    */
   virtual void ConfigureMobility ();
 
   /**
    * \brief Configure applications
-   * \return none
    */
   virtual void ConfigureApplications ();
 
   /**
    * \brief Configure tracing
-   * \return none
    */
   virtual void ConfigureTracing ();
 
   /**
    * \brief Run the simulation
-   * \return none
    */
   virtual void RunSimulation ();
 
   /**
    * \brief Process outputs
-   * \return none
    */
   virtual void ProcessOutputs ();
 
 private:
   /**
    * \brief Run the simulation
-   * \return none
    */
   void Run ();
 
@@ -1159,44 +1116,37 @@
    * \brief Run the simulation
    * \param argc command line argument count
    * \param argv command line parameters
-   * \return none
    */
   void CommandSetup (int argc, char **argv);
 
   /**
    * \brief Checks the throughput and outputs summary to CSV file1.
    * This is scheduled and called once per second
-   * \return none
    */
   void CheckThroughput ();
 
   /**
    * \brief Set up log file
-   * \return none
    */
   void SetupLogFile ();
 
   /**
    * \brief Set up logging
-   * \return none
    */
   void SetupLogging ();
 
   /**
    * \brief Configure default attributes
-   * \return none
    */
   void ConfigureDefaults ();
 
   /**
    * \brief Set up the adhoc mobility nodes
-   * \return none
    */
   void SetupAdhocMobilityNodes ();
 
   /**
    * \brief Set up the adhoc devices
-   * \return none
    */
   void SetupAdhocDevices ();
 
@@ -1205,38 +1155,32 @@
    * as a Basic Safety Message (BSM).  The BSM is typically
    * a ~200-byte packets broadcast by all vehicles at a nominal
    * rate of 10 Hz
-   * \return none
    */
   void SetupWaveMessages ();
 
   /**
    * \brief Set up generation of packets to be routed
    * through the vehicular network
-   * \return none
    */
   void SetupRoutingMessages ();
 
   /**
    * \brief Set up a prescribed scenario
-   * \return none
    */
   void SetupScenario ();
 
   /**
    * \brief Write the header line to the CSV file1
-   * \return none
    */
   void WriteCsvHeader ();
 
   /**
    * \brief Set up configuration parameter from the global variables
-   * \return none
    */
   void SetConfigFromGlobals ();
 
   /**
    * \brief Set up the global variables from the configuration parameters
-   * \return none
    */
   void SetGlobalsFromConfig ();
 
@@ -1382,171 +1326,248 @@
 }
 
 // important configuration items stored in global values
+
+/// Port
 static ns3::GlobalValue g_port ("VRCport",
                                 "Port",
                                 ns3::UintegerValue (9),
                                 ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Number of sink nodes for routing non-BSM traffic
 static ns3::GlobalValue g_nSinks ("VRCnSinks",
                                   "Number of sink nodes for routing non-BSM traffic",
                                   ns3::UintegerValue (10),
                                   ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Trace mobility 1=yes;0=no
 static ns3::GlobalValue g_traceMobility ("VRCtraceMobility",
                                          "Trace mobility 1=yes;0=no",
                                          ns3::UintegerValue (0),
                                          ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Routing protocol
 static ns3::GlobalValue g_protocol ("VRCprotocol",
                                     "Routing protocol",
                                     ns3::UintegerValue (2),
                                     ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Propagation Loss Model
 static ns3::GlobalValue g_lossModel ("VRClossModel",
                                      "Propagation Loss Model",
                                      ns3::UintegerValue (3),
                                      ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Fast Fading Model
 static ns3::GlobalValue g_fading ("VRCfading",
                                   "Fast Fading Model",
                                   ns3::UintegerValue (0),
                                   ns3::MakeUintegerChecker<uint32_t> ());
+
+/// 802.11 mode (0=802.11a;1=802.11p)
 static ns3::GlobalValue g_80211mode ("VRC80211mode",
                                      "802.11 mode (0=802.11a;1=802.11p)",
                                      ns3::UintegerValue (1),
                                      ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Mobility mode 0=random waypoint;1=mobility trace file
 static ns3::GlobalValue g_mobility ("VRCmobility",
                                     "Mobility mode 0=random waypoint;1=mobility trace file",
                                     ns3::UintegerValue (1),
                                     ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Number of nodes (vehicles)
 static ns3::GlobalValue g_nNodes ("VRCnNodes",
                                   "Number of nodes (vehicles)",
                                   ns3::UintegerValue (156),
                                   ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Node speed (m/s) for RWP model
 static ns3::GlobalValue g_nodeSpeed ("VRCnodeSpeed",
                                      "Node speed (m/s) for RWP model",
                                      ns3::UintegerValue (20),
                                      ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Node pause time (s) for RWP model
 static ns3::GlobalValue g_nodePause ("VRCnodePause",
                                      "Node pause time (s) for RWP model",
                                      ns3::UintegerValue (0),
                                      ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Size in bytes of WAVE BSM
 static ns3::GlobalValue g_wavePacketSize ("VRCwavePacketSize",
                                           "Size in bytes of WAVE BSM",
                                           ns3::UintegerValue (200),
                                           ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Verbose 0=no;1=yes
 static ns3::GlobalValue g_verbose ("VRCverbose",
                                    "Verbose 0=no;1=yes",
                                    ns3::UintegerValue (0),
                                    ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Scenario
 static ns3::GlobalValue g_scenario ("VRCscenario",
                                     "Scenario",
                                     ns3::UintegerValue (1),
                                     ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Dump routing tables at t=5 seconds 0=no;1=yes
 static ns3::GlobalValue g_routingTables ("VRCroutingTables",
                                          "Dump routing tables at t=5 seconds 0=no;1=yes",
                                          ns3::UintegerValue (0),
                                          ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Dump ASCII trace 0=no;1=yes
 static ns3::GlobalValue g_asciiTrace ("VRCasciiTrace",
                                       "Dump ASCII trace 0=no;1=yes",
                                       ns3::UintegerValue (0),
                                       ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Generate PCAP files 0=no;1=yes
 static ns3::GlobalValue g_pcap ("VRCpcap",
                                 "Generate PCAP files 0=no;1=yes",
                                 ns3::UintegerValue (0),
                                 ns3::MakeUintegerChecker<uint32_t> ());
+
+/// Simulation start time for capturing cumulative BSM
 static ns3::GlobalValue g_cumulativeBsmCaptureStart ("VRCcumulativeBsmCaptureStart",
-                                                     "Simulation starte time for capturing cumulative BSM",
-                                                     ns3::UintegerValue (0),
-                                                     ns3::MakeUintegerChecker<uint32_t> ());
+                                                     "Simulation start time for capturing cumulative BSM",
+                                                     ns3::TimeValue (Seconds (0)),
+                                                     ns3::MakeTimeChecker ());
 
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange1 ("VRCtxSafetyRange1",
                                           "BSM range for PDR inclusion",
                                           ns3::DoubleValue (50.0),
                                           ns3::MakeDoubleChecker<double> ());
 
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange2 ("VRCtxSafetyRange2",
                                           "BSM range for PDR inclusion",
                                           ns3::DoubleValue (100.0),
                                           ns3::MakeDoubleChecker<double> ());
 
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange3 ("VRCtxSafetyRange3",
                                           "BSM range for PDR inclusion",
                                           ns3::DoubleValue (150.0),
                                           ns3::MakeDoubleChecker<double> ());
 
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange4 ("VRCtxSafetyRange4",
                                           "BSM range for PDR inclusion",
                                           ns3::DoubleValue (200.0),
                                           ns3::MakeDoubleChecker<double> ());
 
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange5 ("VRCtxSafetyRange5",
                                           "BSM range for PDR inclusion",
                                           ns3::DoubleValue (250.0),
                                           ns3::MakeDoubleChecker<double> ());
+
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange6 ("VRCtxSafetyRange6",
                                           "BSM range for PDR inclusion",
                                           ns3::DoubleValue (300.0),
                                           ns3::MakeDoubleChecker<double> ());
+
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange7 ("VRCtxSafetyRange7",
                                           "BSM range for PDR inclusion",
                                           ns3::DoubleValue (350.0),
                                           ns3::MakeDoubleChecker<double> ());
+
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange8 ("VRCtxSafetyRange8",
                                           "BSM range for PDR inclusion",
                                           ns3::DoubleValue (400.0),
                                           ns3::MakeDoubleChecker<double> ());
+
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange9 ("VRCtxSafetyRange9",
                                           "BSM range for PDR inclusion",
                                           ns3::DoubleValue (450.0),
                                           ns3::MakeDoubleChecker<double> ());
+
+/// BSM range for PDR inclusion
 static ns3::GlobalValue g_txSafetyRange10 ("VRCtxSafetyRange10",
                                            "BSM range for PDR inclusion",
                                            ns3::DoubleValue (500.0),
                                            ns3::MakeDoubleChecker<double> ());
+
+/// Transmission power dBm
 static ns3::GlobalValue g_txp ("VRCtxp",
                                "Transmission power dBm",
                                ns3::DoubleValue (7.5),
                                ns3::MakeDoubleChecker<double> ());
+
+/// Total simulation time (s)
 static ns3::GlobalValue g_totalTime ("VRCtotalTime",
                                      "Total simulation time (s)",
                                      ns3::DoubleValue (300.01),
                                      ns3::MakeDoubleChecker<double> ());
+
+/// Interval (s) between WAVE BSMs
 static ns3::GlobalValue g_waveInterval ("VRCwaveInterval",
                                         "Interval (s) between WAVE BSMs",
                                         ns3::DoubleValue (0.1),
                                         ns3::MakeDoubleChecker<double> ());
+
+/// GPS sync accuracy (ns)
 static ns3::GlobalValue g_gpsAccuracyNs ("VRCgpsAccuracyNs",
                                          "GPS sync accuracy (ns)",
                                          ns3::DoubleValue (40),
                                          ns3::MakeDoubleChecker<double> ());
+
+/// Tx May Delay (ms)
 static ns3::GlobalValue g_txMaxDelayMs ("VRCtxMaxDelayMs",
                                         "Tx May Delay (ms)",
                                         ns3::DoubleValue (10),
                                         ns3::MakeDoubleChecker<double> ());
+
+/// CSV filename (for time series data)
 static ns3::GlobalValue g_CSVfileName ("VRCCSVfileName",
                                        "CSV filename (for time series data)",
                                        ns3::StringValue ("vanet-routing.output.csv"),
                                        ns3::MakeStringChecker ());
+
+/// CSV filename 2 (for overall simulation scenario results)
 static ns3::GlobalValue g_CSVfileName2 ("VRCCSVfileName2",
                                         "CSV filename 2 (for overall simulation scenario results)",
                                         ns3::StringValue ("vanet-routing.output2.csv"),
                                         ns3::MakeStringChecker ());
+
+/// PHY mode (802.11p)
 static ns3::GlobalValue g_phyMode ("VRCphyMode",
                                    "PHY mode (802.11p)",
                                    ns3::StringValue ("OfdmRate6MbpsBW10MHz"),
                                    ns3::MakeStringChecker ());
+
+/// Mobility trace filename
 static ns3::GlobalValue g_traceFile ("VRCtraceFile",
                                      "Mobility trace filename",
                                      ns3::StringValue ("./src/wave/examples/low99-ct-unterstrass-1day.filt.7.adj.mob"),
                                      ns3::MakeStringChecker ());
+
+/// Log filename
 static ns3::GlobalValue g_logFile ("VRClogFile",
                                    "Log filename",
                                    ns3::StringValue ("low99-ct-unterstrass-1day.filt.7.adj.log"),
                                    ns3::MakeStringChecker ());
+
+/// Data rate
 static ns3::GlobalValue g_rate ("VRCrate",
                                 "Data rate",
                                 ns3::StringValue ("2048bps"),
                                 ns3::MakeStringChecker ());
+
+/// PHY mode (802.11a)
 static ns3::GlobalValue g_phyModeB ("VRCphyModeB",
                                     "PHY mode (802.11a)",
                                     ns3::StringValue ("DsssRate11Mbps"),
                                     ns3::MakeStringChecker ());
+
+/// Trace name)
 static ns3::GlobalValue g_trName ("VRCtrName",
                                   "Trace name",
                                   ns3::StringValue ("vanet-routing-compare"),
@@ -1605,15 +1626,24 @@
   // devices are set up in SetupAdhocDevices(),
   // called by ConfigureChannels()
 
-  // every device will have PHY callback for tracing
-  // which is used to determine the total amount of
+  // use a PHY callback for tracing
+  // to determine the total amount of
   // data transmitted, and then used to calculate
   // the MAC/PHY overhead beyond the app-data
-  Config::Connect ("/NodeList/*/DeviceList/*/Phy/State/Tx", MakeCallback (&WifiPhyStats::PhyTxTrace, m_wifiPhyStats));
-  // TxDrop, RxDrop not working yet.  Not sure what I'm doing wrong.
-  Config::Connect ("/NodeList/*/DeviceList/*/ns3::WifiNetDevice/Phy/PhyTxDrop", MakeCallback (&WifiPhyStats::PhyTxDrop, m_wifiPhyStats));
-  Config::Connect ("/NodeList/*/DeviceList/*/ns3::WifiNetDevice/Phy/PhyRxDrop", MakeCallback (&WifiPhyStats::PhyRxDrop, m_wifiPhyStats));
+  if (m_80211mode == 3)
+    {
+      // WAVE
+      Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WaveNetDevice/PhyEntities/*/State/Tx", MakeCallback (&WifiPhyStats::PhyTxTrace, m_wifiPhyStats));
+      Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WaveNetDevice/PhyEntities/*/PhyTxDrop", MakeCallback (&WifiPhyStats::PhyTxDrop, m_wifiPhyStats));
+      Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WaveNetDevice/PhyEntities/*/PhyRxDrop", MakeCallback (&WifiPhyStats::PhyRxDrop, m_wifiPhyStats)); 
+    }
+  else
+    {
+      Config::Connect ("/NodeList/*/DeviceList/*/Phy/State/Tx", MakeCallback (&WifiPhyStats::PhyTxTrace, m_wifiPhyStats));
+      Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyTxDrop", MakeCallback (&WifiPhyStats::PhyTxDrop, m_wifiPhyStats));
+      Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyRxDrop", MakeCallback (&WifiPhyStats::PhyRxDrop, m_wifiPhyStats)); 
 }
+    }
 
 void
 VanetRoutingExperiment::ConfigureMobility ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/examples/wave-simple-80211p.cc ns-3.34/src/wave/examples/wave-simple-80211p.cc
--- ns-3.33/src/wave/examples/wave-simple-80211p.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/examples/wave-simple-80211p.cc	2021-07-14 10:31:07.000000000 -0700
@@ -74,6 +74,10 @@
  * MAC class that enables OCB mode.
  */
 
+/**
+ * Receive a packet
+ * \param socket Rx socket
+ */
 void ReceivePacket (Ptr<Socket> socket)
 {
   while (socket->Recv ())
@@ -82,6 +86,13 @@
     }
 }
 
+/**
+ * Geerate traffic
+ * \param socket Tx socket
+ * \param pktSize packet size
+ * \param pktCount number of packets
+ * \param pktInterval interval between packet generation
+ */
 static void GenerateTraffic (Ptr<Socket> socket, uint32_t pktSize,
                              uint32_t pktCount, Time pktInterval )
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/helper/wave-bsm-helper.h ns-3.34/src/wave/helper/wave-bsm-helper.h
--- ns-3.33/src/wave/helper/wave-bsm-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/helper/wave-bsm-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -46,7 +46,6 @@
 public:
   /**
    * \brief Constructor
-   * \return none
    */
   WaveBsmHelper ();
 
@@ -92,7 +91,6 @@
    * \param ranges the expected transmission range, in m.
    * \param chAccessMode channel access mode (0=continuous; 1=switching)
    * \param txMaxDelay max delay prior to transmit
-   * \return none
    */
   void Install (Ipv4InterfaceContainer & i,
                 Time totalTime,          // seconds
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wave/helper/wave-bsm-stats.h ns-3.34/src/wave/helper/wave-bsm-stats.h
--- ns-3.33/src/wave/helper/wave-bsm-stats.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wave/helper/wave-bsm-stats.h	2021-07-14 10:31:07.000000000 -0700
@@ -51,7 +51,6 @@
 public:
   /**
    * \brief Constructor
-   * \return none
    */
   WaveBsmStats ();
 
@@ -63,7 +62,6 @@
   
   /**
    * \brief Increments the count of transmitted packets
-   * \return none
    */
   void IncTxPktCount ();
 
@@ -107,14 +105,12 @@
    * though they may not be physically received (due to collisions
    * or receiver power thresholds).
    * \param index index for statistics
-   * \return none
    */
   void IncExpectedRxPktCount (int index);
 
   /**
    * \brief Increments the count of actual packets received
    * (regardless of coverage area).
-   * \return none
    */
   void IncRxPktCount ();
 
@@ -125,7 +121,6 @@
    * delivery ratio (PDR), we need to count only those received packets
    * that are actually received within the (circular) coverage area.
    * \param index index for statistics
-   * \return none
    */
   void IncRxPktInRangeCount (int index);
 
@@ -153,7 +148,6 @@
    * \brief Sets the count of packets expected to received
    * \param index index for statistics
    * \param count the count of packets
-   * \return none
    */
   void SetExpectedRxPktCount (int index, int count);
 
@@ -161,7 +155,6 @@
    * \brief Sets the count of packets within range that are received
    * \param index index for statistics
    * \param count the count of packets
-   * \return none
    */
   void SetRxPktInRangeCount (int index, int count);
 
@@ -169,21 +162,18 @@
    * \brief Resets the count of total packets
    * expected and/or within range(index) that are received
    * \param index index for statistics
-   * \return none
    */
   void ResetTotalRxPktCounts (int index);
 
   /**
    * \brief Sets the count of packets transmitted
    * \param count the count of packets transmitted
-   * \return none
    */
   void SetTxPktCount (int count);
 
   /**
    * \brief Sets the count of packets received
    * \param count the count of packets received
-   * \return none
    */
   void SetRxPktCount (int count);
 
@@ -191,7 +181,6 @@
    * \brief Increments the count of (application data) bytes transmitted
    * not including MAC/PHY overhead
    * \param bytes the bytes of application-data transmitted
-   * \return none
    */
   void IncTxByteCount (int bytes);
 
@@ -223,7 +212,6 @@
   /**
    * \brief Enables/disables logging
    * \param log
-   * \return none
    */
   void SetLogging (int log);
 
